# MoodyBlues

## Description
The app allows users to explore the environment that affects mental health through a series of graphs that users can freely choose to look for relationships of interest.

youtube link : https://youtu.be/VI4aRX8oNI0

## Data Sources
- [Student Mental Health](https://www.kaggle.com/datasets/shariful07/student-mental-health)
### Columns:
Choose your gender (str), 
Age (int), 
What is your course? (unique str), 
Your current year of Study (int), 
What is your CGPA? (str), 
Marital status (boolean), 
Do you have Depression? (boolean), 
Do you have Anxiety? (boolean), 
Do you have Panic attack? (boolean), 
Did you seek any specialist for a treatment? (boolean)
 
## Running the Application
Requirement
- `Python` >= 3.7 w/ Tk/Tcl installed
- `Pillow` >=9.5.0
- `matplotlib` >=3.7.1
- `pandas` >=2.0.1
- `seaborn` >=0.12.2
- `networkx` >=3.1
- `tk_html_widgets` >=0.4.0
- `beautifulsoup4` >=4.12.2

You can install dependencies by following command.
```bash
pip install -r requirements.txt
```

Make sure you have all the required software installed.
```bash
~/ > git clone https://github.com/SirisilpK/year-project-Nantawat6510545543.git
~/ > cd year-project-Nantawat6510545543
year-project-Nantawat6510545543/ > python main.py
```
 
## Design
### Class Describe
#### Representation Layer
`Frame` Parent class for creating widgets of classes in this layer.

`HomePage` Program homepage

`MainMenuPage` Responsible for switching pages between DetailPage and VisualizePage.

`DetailPage` Shows the basic information of the program.

`VisualizePage` Take the input from the user, send it to VisualizeFacade and get the graph back to show it to the user.

#### Domain Layer
`VisualizeFacade` Facade class for data flow control and graphing

`GraphMaker` Creating graphs

`NetworkGraph` Creating network graph

#### Infrastructure Layer
`DataFrameModifier` Reading and editing data from csv files.

`HTMLReader` Read HTML files

![MoodyBlues class diagram.png](Image%2FMoodyBlues%20class%20diagram.png)

### Sequence diagram
 ![MoodyBlues Sequence diagram.png](Image%2FMoodyBlues%20Sequence%20diagram.png)

The sequence diagram shows the situation in which the user wants to view the default graph.
## Design Patterns Used
The program uses the facade design pattern to control the graphing and manipulate the data from the CSV. It also uses the singleton design pattern, which ensures that only one instance of a facade class can be created.
 
## Graph Algorithm Used
Our project is to create an app that helps users learn about attribute relationships in our data. The graph algorithm facilitates the representation of the relationship between attribute A with attribute B in common.

If the user wants to know the relationship between attribute Ai and Aj with attribute B sharing It is found that Ai and Aj may not have a direct relationship. We therefore need the shortest relationship through the nodes.

Algorithm:
- Breadth First Search

![MoodyBlues network graph example.png](Image%2FMoodyBlues%20network%20graph%20example.png)

example network graph showing relationship between each course and overall mental health sharing.

## Other Information
extra module in the project:
- tk_html_widgets
- beautifulsoup4 

I use these modules to increase the interest of the program. Using tk_html_widgets to display HTML into the program window using beautifulsoup4 to read the file. In addition to the basic charts, users can also select other charts as needed. You can find more information in the [details.html](details.html) or in the application.
